local M = {}
M.addrTb = {}
M.pin = 4 
M.dat = "" 

M.ncom = {
    {0x44}, -- starttemp
    {0xb4}, --startVolt
    {0xb8, 0x00}, -- recallMem
    {0xBE, 0x00}, -- readPage
	
	{0x4e, 0x00, 0x00}, -- setVAD,
    {0x4e, 0x00, 0x08}, -- setVVD
    {0x48, 0x00} -- copySP
}

M.search = function()
	ow.setup(M.pin)
	ow.reset_search(M.pin)
	local adr
	repeat
		adr = ow.search(M.pin)
		if(adr ~= nil) then
			if adr:byte(1) == 0x26 then table.insert(M.addrTb, adr) end
		end
	until (adr == nil)
	ow.reset_search(M.pin)
	print('Got Devices:', #M.addrTb)
end

M.countData = function()
	local crc = ow.crc8(string.sub(M.dat,1,8))
	if crc == M.dat:byte(9) then
		local mb = M.dat:byte(3)
		local raw = (mb > 127) and (-256 + mb) or mb
		local t = (raw + (bit.rshift(M.dat:byte(2), 3)) * 0.03125)
		local v = ((M.dat:byte(5) * 256) + M.dat:byte(4)) / 100
		return t, v
	else
		print('Bad CRC')
		return 85, -1
	end
end

M.writeDS = function(tb, addrNo, read)
	ow.reset(M.pin)
	ow.select(M.pin,  M.addrTb[addrNo])
	for _, v in pairs(tb) do
		ow.write(M.pin, v, 1)
	end
	if read then M.dat = ow.read_bytes(M.pin, 9) end
	ow.reset(M.pin)
end

M.update = function(dattbl, call, pin)
	M.pin = pin or M.pin
	if #M.addrTb == 0 then M.search() end
	if #M.addrTb == 0 then print("No  unit!"); return end
	
	local adrNo = 1
	local askNo = 1
	local voltNow = 0
	
	local getnow
	getnow = function()
		M.writeDS(M.ncom[1], adrNo, false)
		local interval = 10
		local nextcom = 2
		local step
		step = function()
			tmr.create():alarm(interval, 0, function()
				interval = 4
				M.writeDS(M.ncom[nextcom], adrNo, (nextcom == 4))
				if nextcom == 4 then
					local t, v = M.countData()
					local as = ""
					local numm = 0
					for ii = 1, #M.addrTb[adrNo] do
						local hx = string.format("%02X", (string.byte(M.addrTb[adrNo], ii)))
						as = as ..hx
						local dd = tonumber(hx)
						if dd then 
						numm = numm + dd 
						end
					end
					-- Раскомментировать для получения более короткого имени датчика
					-- as = "" .. numm
					if askNo == 1 then
						askNo = 2
						voltNow = v
						dattbl["temp"..as] = t
						M.writeDS(M.ncom[5], adrNo, false)
						M.writeDS(M.ncom[7], adrNo, false)
						getnow()
					else
						askNo = 1
						M.writeDS(M.ncom[6], adrNo, false)
						M.writeDS(M.ncom[7], adrNo, false)
						print('Power Now', voltNow)
						print('Got Volt', v)
						local hum = (((v/voltNow) - 0.1515)/0.00636)/(1.0546 - 0.00216 * t)
						dattbl["Humi"..as] = hum
						dattbl["AbsH"..as] = ((6.112*(math.pow(2.718281828,(17.67*t)/(t+243.5)))*hum*2.1674)/(273.15+t))
						adrNo = adrNo + 1
						if adrNo > #M.addrTb then
							if call then call(dattbl) end
						else
							getnow()
						end
					end
				else
					nextcom = nextcom +1
					step()
				end
			end)
		end
		step()
	end
	getnow()
end
return M